#!/usr/bin/env python
"""A sample web-based bug tracker.

http://localhost:8485/

Prerequisites:

 * install postgres server (apt-get install postgresql python-pgsql)
 * make yourself a user (su postgres -c adduser yourname)
 * create a database (createdb twisted)
 * set up bugs tables (psql --dbname twisted --file schema.sql)
"""

from twisted.internet import main
from twisted.spread import pb
from twisted.enterprise import adbapi, dbcred
from twisted.web import widgets, server

from Bugs import gadgets, bugsdb, service


# Connect to a database.
dbpool = adbapi.ConnectionPool("pyPgSQL.PgSQL", database="twisted")

# Create Twisted application object
application = main.Application("Bugs")
svc = service.Service("twisted.bugs", application)
svc.createPerspective("admin").makeIdentity("admin")

# Create posting board object
gdgt = gadgets.BugsGadget(bugsdb.BugsDatabase(dbpool), svc)

# Accept incoming connections!
s = server.Site(gdgt)
s.app = application
application.listenTCP(8485, s)

# Done.
